﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace BowHowdy.Erb
{
    /// <summary>
    /// Interaction logic for EditRule.xaml
    /// </summary>
    public partial class EditRule : Window
    {
        TextBox _listBox;
        string _rule;
        public bool closeWindow;

        public EditRule(TextBox listBox, string rule)
        {
            InitializeComponent();
            _listBox = listBox;
            _rule = rule;
            if (rule != null)
            {
                ParseRule();
            }
        }

        private void ParseRule()
        {
            var newRule = _rule.Replace(@"(\d+)", "ENTER_NUMBER").Replace(@"(.+)", "ENTER_VALUE").Replace(@"(\w+)", "CONTEXT_PROPERTY");
            if (newRule == _rule) // nothing changed, just add it, no input parameters
            {
                closeWindow = true;
                _listBox.Text += newRule + "\n";
                this.Close();
            }
            else
            {
                _rule = newRule;
                textBox1.Text = _rule;
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                _listBox.Text += (textBox1.Text + "\n");
                this.Close();
            }
            if(e.Key == Key.Escape) this.Close();

        }
    }
}
