﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using BoyHowdy.Erb.Lib.RuleEngine;
using BoyHowdy.Erb.Lib.RuleSets;

namespace BowHowdy.Erb
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Type _LastSelectRuleSetType;
        private string _SouthernRules = "If they done gone and answered question 1 as Very Satisfied\nAnd client done been here before\nThen send 'em one of them there fancy discount coupons\nIf they done gone and answered question 1 as Very Unsatisfied\nThen send one of those electronic mails to clientrelations@boyhowdy.com\nIf they done gone and answered question 1 as Yes\nThen subscribe 'em to that there newsletter\nIf they done gone and answered question 4 as Yes\nThen use that calling device and call 'em back in 6 months\n";
        private string _SurveyRules = "If answer to question 1 is Very Satisfied\nAnd client is a repeat client\nThen send them a discount coupon in the mail\nIf answer to question 1 is Very Unsatisfied\nThen send survey via email to clientrelations@boyhowdy.com\nIf answer to question 3 is Yes\nThen subscribe them to newsletter\nIf answer to question 4 is Yes\nThen schedule a follow up call in 6 months\n";
        public static IEnumerable<string> Rules;

        public MainWindow()
        {
            InitializeComponent();
            // demo rules to pre-load
            tbBusinessRules.Text = _SurveyRules;
            LoadRuleSets();
        }

        private void LoadRuleSets()
        {
            lbRuleSets.Items.Clear();
            foreach (var ruleType in Engine.FindAllRuleSetTypes())
            {
                if (ruleType.Name == "IRuleSet" || ruleType.Name == "RuleSetBase") continue;
                lbRuleSets.Items.Add(ruleType);
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            LoadRuleSets();
        }

        private void listBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            lbRules.Items.Clear();
            _LastSelectRuleSetType = (Type)lbRuleSets.SelectedItem;
            Rules = Engine.GetAllRulesForRuleSet(_LastSelectRuleSetType);
            foreach (var item in Rules)
            {
                lbRules.Items.Add(item);
            }
        }

        private void lbRules_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            EditRule form = new EditRule(tbBusinessRules, (string)lbRules.SelectedItem);
            if (!form.closeWindow)
            { form.Show(); }
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            List<string> rules = new List<string>();
            foreach (var item in tbBusinessRules.Text.Split('\n'))
            {
                rules.Add(item);
            }
            try
            {
                // this is a hack but it works for this demo
                if (_LastSelectRuleSetType.Name == "SurveyRuleSet")
                    textBox1.Text = RuleParser.ToRubyScript<SurveyRuleSet>(rules);
                if (_LastSelectRuleSetType.Name == "SouthernRuleSet")
                    textBox1.Text = RuleParser.ToRubyScript<SouthernRuleSet>(rules);
            }
            catch
            {
                MessageBox.Show("Error parsing rules");
            }
        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            tbBusinessRules.Text = String.Empty;
        }

        private void button5_Click(object sender, RoutedEventArgs e)
        {
            Survey s = new Survey(textBox1.Text, _LastSelectRuleSetType.Name);
            s.Show();
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            tbBusinessRules.Text = _SouthernRules;
        }

        private void button6_Click(object sender, RoutedEventArgs e)
        {
            tbBusinessRules.Text = _SurveyRules;
        }
    }
}
