﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using BoyHowdy.Erb.Lib.Common;
using BoyHowdy.Erb.Lib.Domain.Survey;
using BoyHowdy.Erb.Lib.RuleSets;

namespace BowHowdy.Erb
{
    /// <summary>
    /// Interaction logic for Survey.xaml
    /// </summary>
    public partial class Survey : Window
    {
        string script;
        string _ruleSetName;
        public Survey(string rubyScript, string ruleSetname)
        {
            InitializeComponent();
            script = rubyScript;
            _ruleSetName = ruleSetname;
            // if this looks like greek, what this does is wire up an action so logs from the ruleSet
            // when executed are sent into the WPF listbox
            Log.WriteLine = str => listBox1.Dispatcher.Invoke(new Action(() => listBox1.Items.Add(str)));
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            ExecuteRules();
        }
        private void ExecuteRules()
        {
            listBox1.Items.Clear();
            var s = new BoyHowdy.Erb.Lib.Domain.Survey.Survey();
            s.Questions.Add(new Question()
            {
                Answer = a1.Text,
                Description = q1.Text,
                Number = 1
            });
            s.Questions.Add(new Question()
            {
                Answer = a2.Text,
                Description = q2.Text,
                Number = 2
            });
            s.Questions.Add(new Question()
            {
                Answer = a3.Text,
                Description = q3.Text,
                Number = 3
            });
            s.Questions.Add(new Question()
            {
                Answer = a4.Text,
                Description = q4.Text,
                Number = 4
            });
            s.Questions.Add(new Question()
            {
                Answer = a5.Text,
                Description = q5.Text,
                Number = 5
            });
            s.RepeatClient = true;
            // hack just for demo purposes
            if (_ruleSetName == "SurveyRuleSet")
                BoyHowdy.Erb.Lib.RuleEngine.Engine.Execute<SurveyRuleSet>(script, new SurveyRuleSet(s));
            if (_ruleSetName == "SouthernRuleSet")
                BoyHowdy.Erb.Lib.RuleEngine.Engine.Execute<SouthernRuleSet>(script, new SouthernRuleSet(s));
        }
    }
}
