﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BoyHowdy.Erb.Lib.RuleEngine;

namespace BoyHowdy.Erb.Lib.RuleSets
{
    public class UrinalRuleSet : IRuleSet
    {
        public static int? Solve(bool[] stalls, bool queued)
        {
            var positions = new List<Tuple<int, bool>>();
            for (int i = 0; i < stalls.Length; i++)
            {
                positions.Add(new Tuple<int, bool>(i, stalls[i]));
            }

            var result = positions.Where(x => x.Item2 == false
                && (Neighbors(positions, x.Item1) == 0
                || Neighbors(positions, x.Item1) == 1 && (queued || positions.Any(x1 => x1.Item2 && Neighbors(positions, x1.Item1) == 1))
                || Neighbors(positions, x.Item1) == 2 && (queued || positions.Any(x1 => x1.Item2 && Neighbors(positions, x1.Item1) == 2))))
                .OrderBy(x => Neighbors(positions, x.Item1))
                .ThenByDescending(x => x.Item1)
                .FirstOrDefault();

            return result != null ? result.Item1 : (int?)null;
        }

        private static int Neighbors(IEnumerable<Tuple<int, bool>> positions, int index)
        {
            return positions.Count(x => x.Item2 && Math.Abs(index - x.Item1) == 1);
        }
    }
}
